# -* perl path line above auto-generated *-
use warnings;
use strict;
use IO::Handle;
############################################################################
#									                                       #
# Copyright (C) 2006 Mike Lear <mikeofthenight2003@yahoo.com>		       #
#									                                       #
# This file is free software; as a special exception the author gives	   #
# unlimited permission to copy and/or distribute it, with or without	   #
# modifications, as long as this notice is preserved.			           #
#									                                       #
# This program is distributed in the hope that it will be useful, but      #
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the   #
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. #
#									                                       #
############################################################################
Filter();

    while (<>) {
	print;
    }
    close STDOUT;
    exit;

sub Filter {
    use vars qw($pid $line $message $filename $lineno $before);
	    return if $pid = open (STDOUT, "|-");
    die "Cannot fork: $!"    unless defined $pid;
	while ($line = ARGV->getline()) {
	    chomp($line);
	    
	if ($line =~ /^(.*\d+:)\swarning:\s(.*)$/ ) {
	    ($lineno,$message) = ($1,$2);
	    print ""; 
	}
	elsif ($line =~ /^(.*\.o.*\/)(.*):(\d+):(.*)$/ ) {
	    ($lineno,$before,$filename,$message) = ($1, $2, $3, $4);
	    print "$before:$filename:$message:\n";
	    }
	elsif
	    ($line =~ /^(.*):(\d+):\s(.*)$/) { 
		($filename,$lineno,$message) = ($1, $2, $3);
  	    print "$filename:$lineno:$message:\n";    
		}
	    elsif
	  ($line =~ /^(.*)\sat\s(.*)\sline\s(\d+)(\.|,\snear\s\".*\")$/) {
		($message, $filename, $lineno, $before) = ($1, $2, $3, $4);
			$message .= $before if ($before =~ s/^,//); 
  	    print "$filename:$lineno:$message:\n";   
		}
	    else  { next;  }
	}
    exit(0);
}
