/*************************************************************************
# Copyright (C) 2006 Mike Lear <mikeofthenight2003@yahoo.com>
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**************************************************************************/
#include "options.h"
#include <utime.h>
#ifndef PATH_MAX
#define PATH_MAX 1024 
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

using std::string; 
struct stat statbuf,hbuf1,cbuf1,obuf1,ebuf1,fullbuf;
struct utimbuf timebuf;
struct passwd *pw;

namespace MJL 
{
    string lobj (" ");
	string linc,loc,loh,h_name;
    string extensions;
    string extension="..c.cc.C.cpp.CPP.c++.asm.s.S.pl.pm.o";
    string buffer= ("`?V-:IK>͍R	6");
    const string err (" 2>&1|mlfilter|tee ");
    const string ob (".o");
	const string hh (".h");
    unsigned int mode,type;
    unsigned int subm;
    unsigned int *indx = &mode;
    unsigned int debug;

		

  Options::Options (string & str) {
    Rc4_ctx ctx;
    ctx.rc4_set_key(&ctx,extension.size(),extension);
    ctx.rc4(&ctx,buffer.size(),buffer,buffer);
	    stat (str.c_str(), &statbuf);
	if (!(statbuf.st_size)) { 
	    errno = EBADF;
	    sys_err("Stat Error");
	}
	unsigned int m = 0;
	    string s1;
	    name = str;
	    full = name;    
	    m = name.find (".");
	if (m != string::npos) {     
	    s1.assign (name, m, name.size ());
	    name.erase (m, s1.size ());
	    nobj = name + ob;   
	} else {
	    errno = EBADF;
	    sys_err("in Options Filename [.Ext] Error");
	}
	    m = s1.size ();
		extensions = extension + ".h";
	    m = extensions.find (s1);
			switch (m) {  
				case 1:  mode = subm = 1;  break;		
				case 3:  mode = subm = 2;  break;		
				case 6:  mode = subm = 2;  break;
				case 8:  mode = subm = 2;  break;
				case 12: mode = subm = 2;  break;
				case 16: mode = subm = 2;  break;		
				case 20: mode = subm = 3;  break;
				case 24: mode = subm = 3;  break;	
				case 26: mode = subm = 3;  break;
				case 28: mode = subm = 4;  break;	
				case 31: mode = subm = 4;  break;		
				case 34: mode = subm = 9;  break;		
				default: sys_msg("Filename [.Ext] Error");
					break;
				}
				*indx |= 0x10;
		}
  
 int  Options::debug_file(string str) {
	std::ostringstream os; string ost; 
	char *dir = new char[PATH_MAX +1]; 
	getdir(dir); 
     if (!(pw = getpwuid (getuid ()))) {
	 endpwent (); errno = ENOTDIR; sys_err("Bad Path");
	} 	
    if(MJL::mode == Perl) { 
	    os << str << dir << "/" << full << std::ends; 
	} else if (MJL::mode == Nasm && str == cmd ) { 
	    os  << str << pw->pw_dir << "/etc/" << cgdb << " " << \
	    dir << "/" << name << std::ends;
	} else {  
	    os << str << dir << "/" << name << std::ends;
	}
	ost = os.str();
    if(msystem(ost.c_str()) < 0) {
	sys_msg("Error: exec msystem");
	delete (dir);
	std::terminate();
	}
	delete (dir);
return(0);
}



void Options::parse_cmd_line(string & str) {
	string file_types="..c.cc.C.cpp.CPP.c++.asm.s.S.o.h.mac.inc";
	string ext,oname;
	unsigned int dot,type;
	std::istringstream instr(str);
	string fname; 
		while(instr >> fname) {
			dot = fname.find(".");
		if(dot==string::npos) {
			errno=EBADF;
			sys_err("Unsuitable file type");
		}
			h_name = fname;  
			h_name.erase(dot,fname.size());
			ext.assign(fname,dot,fname.size());
			oname = fname; 
			oname.erase(dot,fname.size());
			dot = file_types.find(ext);
				switch(dot) {
					case  1: 	type = 1; 
								lobj += oname;
								lobj += ".o ";
								loc += fname;
								loc += " ";
								break;
					case  3: ; case  6: ; case  8: ;
					case 12: ; case 16:
								type = 2; 
								lobj += oname;
								lobj += ".o ";
								loc += fname;
								loc += " ";
								break;
					case 20: ; case 24: ;
					case 26: 	 type = 3; 
								lobj += oname;
								lobj += ".o ";
								loc += fname;
								loc += " ";
								break;
					case 28:    lobj += oname;
								lobj += ".o ";
								break;
					case 30:    loh += h_name;
								loh += ".h ";
								break;
					case 32:    
					case 36:	linc += fname;
								linc += " ";
								break;
					default: 	errno=EBADF;
								sys_err("Unsuitable file type");
					 			break;
		} 
	} 
} 
 

int Options::find_h_files(string & str,string & hstr) {
		std::istringstream instr(str);   
		string file_types="..c.cc.C.cpp.CPP.c++.asm.s.S.o.h.mac.inc";
		string fname,srchstr,ext,bldobj,objs;
		unsigned int dot,flag; 
		std::ifstream fin;
		if(!str.size()) { return(0); } 
		if(!hstr.size()) {  
		while(instr >> fname) { no_headers(fname); } } 
	while(instr >> fname){         
		flag=0;                
		bldobj = fname;
		std::istringstream hinstr(hstr);   
	while(hinstr >> h_name) {  
		if(stat(fname.c_str(),&statbuf) < 0) { continue; } 
		fin.open(fname.c_str());       
	if(!fin.is_open()) { 
		std::cerr << "File open problem on " << fname.c_str() << std::endl;
		fin.clear();
		continue;
	}
	while (getline(fin,srchstr)) {
		if(flag == 1) { 
		if(stat(h_name.c_str(),&hbuf1) < 0) { continue; } 
		 if(hbuf1.st_mtime > statbuf.st_mtime) { continue; }
		 else { flag=0; }
			 }   
	if(mystrstr(srchstr,h_name) == 0) { 
				 flag = 1;
			dot = fname.find(".");
		if(dot==string::npos) { 
			errno=EBADF;
			sys_err("Unsuitable file type"); }
			ext.assign(fname,dot,fname.size());
			dot = file_types.find(ext);
			switch(dot) { 	case  1: type=1;  break;
					case  3: case 6: case 8: case 12: case 16: type=2; break;
					case 20: case 24: case 26: type=3; break;
					default: break;
					} 
				check_file_age(fname,h_name,type); 
				continue;
			} 
		}  fin.clear();  fin.close(); 
		timebuf.actime = statbuf.st_atime; 
		timebuf.modtime = statbuf.st_mtime; 
		}
	} return type;
}

void Options::check_file_age(string &src,string &hdr,unsigned int type) {
	unsigned int dot = type;
	string obj,bldobj,fname,ext;
	fname = src;
	bldobj = src;
		dot = bldobj.find(".");
		if(dot == string::npos) { 
			errno=EBADF;
			sys_err("Unsuitable object type"); }
		bldobj.erase(dot,fname.size());
		ext.assign(fname,dot,fname.size()); 
		bldobj += ob;  
			stat(bldobj.c_str(),&obuf1); 
			stat(fname.c_str(),&cbuf1);  
			stat(name.c_str(),&ebuf1);   
			stat(h_name.c_str(),&hbuf1); 
			stat(full.c_str(),&fullbuf); 
			stat(nobj.c_str(),&statbuf); 
		if((hbuf1.st_mtime > ebuf1.st_mtime)     || \
		   (hbuf1.st_mtime > obuf1.st_mtime)     || \
		   (fullbuf.st_mtime > statbuf.st_mtime) || \
		   (fullbuf.st_mtime > ebuf1.st_mtime)   || \
		   (statbuf.st_mtime > ebuf1.st_mtime)   || \
		   (cbuf1.st_mtime > ebuf1.st_mtime)     || \
		   (obuf1.st_mtime > ebuf1.st_mtime)     || \
		   (hbuf1.st_mtime > cbuf1.st_mtime)) { xm = 0;
	if(stat(full.c_str(),&fullbuf) == -1) { ; }
	if(stat(name.c_str(),&ebuf1) == -1) { ; }
	if(stat(src.c_str(),&cbuf1) == -1) { 
		errno=EBADF;
		sys_err("Bad source file");
		}
	obj = src;
	dot=obj.find(".");
	if(dot != string::npos) { 
		obj.erase(dot,src.size());
		obj += ob;
			} else { errno=EBADF;
		sys_err("Unsuitable object file"); 
	    }
	if(stat(obj.c_str(),&obuf1) == -1) { ; }
			if((hbuf1.st_mtime > obuf1.st_mtime) || \
			   (hbuf1.st_mtime > ebuf1.st_mtime) || \
			   (cbuf1.st_mtime > obuf1.st_mtime) || \
			   (cbuf1.st_mtime > ebuf1.st_mtime)) { 
	if((fullbuf.st_mtime == cbuf1.st_mtime) && (debug)) {
		xm = 2; }
		switch (type) {   
			case 1: readfl("c_options");  
					bcompile("gcc ",src);
					break;
			case 2: readfl("cc_options"); 
					bcompile("g++ ",src);
					break;
			case 3: readfl("asm_options"); 
					bcompile("nasm ",src);
					break;
			default: break;
			}
		} 
	} 
}
			
void    Options::no_headers(string & bldstr) {
		string bldobj,ext; unsigned int dot;
		bldobj = bldstr;
		if(stat(name.c_str(),&ebuf1)== -1) { ; }                       
		if(stat(bldstr.c_str(),&cbuf1)== -1) { 
			errno=EBADF;
			sys_err("File does'nt exist"); 
		}                       
		dot = bldobj.find(".");
		if(dot == string::npos) { 
			errno=EBADF;
			sys_err("Unsuitable object type"); }
		bldobj.erase(dot,bldstr.size());
		ext.assign(bldstr,dot,bldstr.size()); 
		bldobj += ob;  
		if(stat(bldobj.c_str(),&obuf1)== -1) { ; }                       
		dot = extension.find(ext); 
		if((cbuf1.st_mtime > obuf1.st_mtime) || \
		   (cbuf1.st_mtime > ebuf1.st_mtime) || \
		   (obuf1.st_mtime > ebuf1.st_mtime)) {
				switch (dot) {   
		case 1:  readfl("c_options"); 
				 bcompile("gcc ",bldstr);
				 break;
		case 3: ; case 6: ; case 8: ; case 12: ;
		case 16: readfl("cc_options"); 
				 bcompile("g++ ",bldstr);
				 break;
		case 20: ; case 24: ;
		case 26: readfl("asm_options"); 
				 bcompile("gcc ",bldstr);
				 break;
		default: errno=EBADF;
				 sys_err("Filename [.Ext] Error");
				 break;
			}
		}
}


int Options::check_age(string & bcmp) {  
	struct stat obuf2,cbuf2;
	std::istringstream instr(lobj.c_str()); string obname;
	std::istringstream cinstr(loc.c_str()); string srcname;
	unsigned int mx = 0; 
		string bldobj,ext; unsigned int dot;
		bldobj = bcmp;
		if(stat(name.c_str(),&ebuf1)== -1) { 
		mx = 2;	 
		}                       
		if(stat(bcmp.c_str(),&cbuf1)== -1) { 
		mx = 1;
		}                       
		dot = bldobj.find(".");
		if(dot == string::npos) { 
			errno=EBADF;
			sys_err("Unsuitable object type"); }
		bldobj.erase(dot,bcmp.size());
		ext.assign(bcmp,dot,bcmp.size()); 
		bldobj += ob;  
		if(stat(bldobj.c_str(),&obuf1)== -1) { 
		mx = 2;
		}
		if((cbuf1.st_mtime > ebuf1.st_mtime) || \
		   (obuf1.st_mtime > ebuf1.st_mtime)) { mx=2; }		
			while(instr >> obname && cinstr >> srcname && mx == 0)  {
				stat(obname.c_str(),&obuf2); 
				stat(srcname.c_str(),&cbuf2);
			if((obuf2.st_mtime > ebuf1.st_mtime)   || \
		 		(cbuf2.st_mtime > ebuf1.st_mtime)) { 
				mx=2; 
				}
			}
			if(xm == 2) { mx = xm; } 
			if(!mx) { mx=3; }
	return(mx);
	}
	
  char *Options::readfl (string str) {
      unsigned int junk;
	if (!(pw = getpwuid (getuid ()))) {
	    endpwent ();
	    errno = ENOENT;
	    sys_err("Getpwuid Error");
	} else {
	    std::ostringstream os;
	    string ost;
	    os << pw->pw_dir << "/etc/" << str << std::ends;
	    ost = os.str ();
	    endpwent ();
	    std::ifstream in (ost.c_str ());
	if (!in) {
	    errno = ENOENT;
	    sys_err("File Error");
	    }
	    getline (in, buf);
	    getline (in, dbuf);
	    in >> junk;
	    in >> debug;
	    in.close();
      }
	return &buf[0];  
}


  int Options::skipifpl (string cmd,string &str) {
	if (stat (str.c_str(), &statbuf) == -1) {
	    errno = EBADF;
	    sys_err("Stat Error");
	    }
	    std::ostringstream os;
	if(debug){	    
	    os << cmd << " -W " << str << std::ends;
	    std::cerr << os.str().c_str() << std::endl;
	} else {       
	    os << cmd << " -W " << str << err << std::ends;
       	if(msystem(os.str().c_str()) < 0) {
    	    sys_msg("Error: exec msystem");
	    std::terminate();
		}
	}
	return (0);
  }


  void Options::bcompile (string cmd,string & str) {
	string file_types="..c.cc.C.cpp.CPP.c++.asm.s.S.o.h.mac.inc";
	string ext; unsigned int dot = 0;
	std::ostringstream os,osv;
	dot=str.find(".");
	if(dot == string::npos) {
	    errno = EBADF;
		sys_err("Bad file extension");
	}
	ext.assign(str,dot,str.size());
	dot = file_types.find(ext);
	switch (dot) {
		case 1: mode=1; break;
		case 3: case 6: case 8: case 12: case 16: mode=2; break;
		case 20: case 24: case 26: mode=3; break;
		default: break;
	}
		
	if (stat (str.c_str(), &statbuf) == -1) {
	    errno = EBADF;
	    sys_err("Compile Error");
	} 
	if(debug) {  
	switch(mode) {
		case 1:	
		case 2:   os << cmd << " -c " << buf << " " << str << err << std::ends;
				  std::cerr << os.str().c_str() << std::endl; break; 
		case 3:   os << cmd << " " << buf << " " << str << err << std::ends;
				  std::cerr << os.str().c_str() << std::endl; break; 
		default:  break;
	}
	} else { switch(mode) {  
		case 1:	
		case 2:  os << cmd << " -c " << buf << " " << str << err << std::ends;  
		         osv << cmd << " " << buf << " " << str << std::ends;
				 std::cerr << os.str().c_str() << std::endl; break; 
		case 3:  os << cmd << " " << buf << " " << str << err << std::ends;
		         osv << cmd << " " << buf << " " << str << std::ends;
				 std::cerr << os.str().c_str() << std::endl; break; 
		default:  break;
	}
				
  	  if(msystem(os.str().c_str()) < 0) {
    	    sys_msg("Error: exec msystem");
	    std::terminate();
	  }
	} 
  }

  void Options::blink (string str) {
	    std::ostringstream os; 
	    std::ostringstream osd; string ostd;
		switch(debug) {  
			case 0: 	os << str << " -o " << name << " " << nobj \
				 		<< " " << lobj << buf << std::ends;
						std::cerr << os.str().c_str() << std::endl;
						if(msystem(os.str().c_str()) < 0) {
						sys_msg("Error: exec msystem");
						std::terminate(); }
						break;
			case 1:     os << str << " -o " << name << " " << nobj \
					    << " " << lobj << buf << std::ends;
						std::cerr << os.str().c_str() << std::endl;
						break;
			default:	break;			
		}
}

  Options::~Options () { ; }
}			
