/*************************************************************************
# Copyright (C) 2006 Mike Lear <mikeofthenight2003@yahoo.com>
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**************************************************************************/
#ifndef OPTIONS_H_
#define OPTIONS_H_
#ifndef __GNUC__
#define __asm__ asm
#endif
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <signal.h>
#include <string>
#include <cstdlib>
#include <sstream>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include <pwd.h>
#include <exception>
using std::string;

namespace MJL {
//debugging macros ML(variable or string);
#define ML(z) std::cerr << #z " = " << z << std::endl;    
#define LM(z) std::cerr << #z " = " << z << " ";    

extern unsigned int mode,debug,*indx;
extern string buffer,loh,loc,linc;
extern string h_name;
const string cmd("gdb -q -x ");
const string cgdb("gdbinit");
int  msystem(const char *str);
void sys_err(const char *str);
void sys_msg(const char *str);
void  getdir(char *dir);
void last_chance();
void copy_right(unsigned long,string & str);

const unsigned int StdC   = 1;    
const unsigned int Cplus  = 2;
const unsigned int Nasm   = 3;
const unsigned int Perl   = 4;


inline bool mystrstr(const std::string& strA,const std::string &strB) {
	    //            haystack --- needle
	    return strstr(strA.c_str(),strB.c_str()) == 0;
}

	class Rc4_ctx {
			unsigned char swap;
			unsigned char sbox[256];
			unsigned char i,j;
		public:
			void rc4_set_key(Rc4_ctx *c, size_t keybytes,std::string & key);
			void rc4(Rc4_ctx *c, size_t n,std::string & in,std::string & out);
	};


	
    class Options {
		protected:
			string name;
			string buf;
			string dbuf;
			string nobj;
			string full;  
			unsigned int xm;
		private:
	        int mmode;
		public:
			Options(string & str);
			char *readfl(string str);
			void bcompile(string cmd,string & str);
			void blink(string str);
			void makeobj(string & str);
			void no_headers(string & str);
			void parse_cmd_line(string & str);
			void check_file_age(string &str,string &hdr,unsigned int);
			void show_name(void){ std::cout << name.c_str() << " is up to date." << std::endl;}
			int find_h_files(string & str,string & hstr); 
			int skipifpl(string cmd,string & str);
			int runame(void);
			int check_age(string & str);
			int runame(string & str);
			int debug_file(string str);
			~Options(); 
    };


}
#endif //OPTIONS_H_
